-- Usage:
-- Import this before defining any objects.
if DIAGNOSTICS_ON then

local orig_defineObject = defineObject

local function getName(component)
	return component.name or component.class:lower()
end

Config.diagData = {}
Config.diagData.totalObjectsDefined = 0
Config.diagData.definedObjects = {}
Config.diagData.weapons = {}

defineObject = function(def)
	if not Config.diagData.definedObjects[def.name] then
		Config.diagData.definedObjects[def.name] = def
		Config.diagData.totalObjectsDefined = Config.diagData.totalObjectsDefined+1
	end
	if def.name == "party" and not def.baseObject then
		table.insert(def.components,{
			class = "Null",
			name = "diagnosticsLoader",
			onInit = function(self)
				self.go.diagnostics:loadFile("mod_assets/ext/diagnostics/diagnostics_script.lua")
			end})
		table.insert(def.components,{
			class = "Script",
			name = "diagnostics",
			})
	end
	local weaponComponents = {
		FirearmAttack=true,
		MeleeAttack=true,
		RangedAttack=true,
		ThrowAttack=true
	}
	local weapon
	if Config.diagData.weapons[def.baseObject] then
		weapon = true
	elseif def.components then
		for _,component in ipairs(def.components) do
			if weaponComponents[component.class] then
				weapon = true
				break
			end
		end
	end
	if weapon then
		Config.diagData.weapons[def.name] = def
	end
	orig_defineObject(def)
end

import "mod_assets/ext/diagnostics/objects.lua"

end
